/*
 * c1-defs.h
 * Copyright (C) 2006-2014, 2016, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __LIBx1f4_c1_DEFS_H__
#define __LIBx1f4_c1_DEFS_H__

/*
 * error definitions
 */
#define ALLOC_ERROR			1
#define PARSE_ERROR			2

/*
 * completion definitions
 */
#define BACK_COMPLETION			0
#define BYTE_COMPLETION			1
#define TURN_COMPLETION			2

/*
 * generation flag definitions
 */
#define CODELINK_LINK			(1L << 0x01)
#define COMPOSER_LINK			(1L << 0x02)
#define DIRECT_ACCESS			(1L << 0x03)
#define DISPATCH_LINK			(1L << 0x04)
#define ERROR_STORAGE			(1L << 0x00)
#define IMPLICIT_LINK			(1L << 0x05)
#define LEAD_DATATEXT			(1L << 0x06)
#define LINE_OPTIMIZE			(1L << 0x07)
#define RELATION_LINK			(1L << 0x08)
#define RESOURCE_LINK			(1L << 0x09)
#define SIDELIST_LINK			(1L << 0x0b)
#define SKIP_SCOMMENT			(1L << 0x0a)
#define SUIT_SLIPTEST			(1L << 0x0c)
#define TEXTFLAT_LINK			(1L << 0x0d)
#define TRANSFER_LINK			(1L << 0x0e)
#define TURNCAST_LINK			(1L << 0x0f)
#define TYPELIST_LINK			(1L << 0x10)

/*
 * node state bit definitions
 */
#define LINE_COPY			((1L << 0x1c) - 1)

/*
 * node state bit definitions (continued)
 */
#define Fst_STATE			(1L << 0x1f)

/*
 * record definitions
 */
#define HINT_MASK			(1L << 0x0)

/*
 * variables collections construction error definitions
 */
#define FRAME_ERROR			1
#define NAMES_CLASH			2

#endif				/* __LIBx1f4_c1_DEFS_H__ */
