/*
 * c1.b.c
 * Copyright (C) 2008-2012, 2015, 2016, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <stddef.h>

#include <c1-defs.h>
#include <c1-inter.h>
#include <c1-types.h>
#include <e4.h>

static int peek_aime(void *, const struct x1f4_function_type *);
static int rail_aime(void *, struct c1_node_type *);

static int
peek_aime(void *none, const struct x1f4_function_type *function_data)
{
    return function_data->flags & (X1f4_E4_LEAD_CALL | X1f4_E4_WALK_LINK);
}


static int
rail_aime(void *none, struct c1_node_type *node_data)
{
    do {
	int delete;
	void *data;

	data = node_data->data.data;
	if (data) {
	} else {
	    data = (node_data + 1)->data.data;
	    if (data) {
	    } else {
		break;
	    }
	}

	delete = x1f4_peek_expression(data, NULL, peek_aime);
	if (delete) {
	    node_data->state |= Fst_STATE;
	} else {
	    delete = x1f4_rate_expression(data);
	    if (delete) {
		node_data->state |= Fst_STATE;
	    }
	}
    } while (0);

    return 0;
}


int
x1f4_rail_program(struct c1_program_type *program_data)
{
    return x1f4_list_program(program_data, NULL, rail_aime);
}
