/*
 * c1.s.c
 * Copyright (C) 2008, 2009, 2013, 2014, 2016, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <stddef.h>

#include <c1-defs.h>
#include <c1-inter.h>
#include <c1-types.h>

int
x1f4_near_routine(struct c1_trans19_type **trans19,
		  struct c1_program_type *program_data)
{
    int status;
    void *data;

    status = program_data->n.link
	(program_data->n.data, &data, sizeof(struct c1_trans19_type));
    if (status) {
	status = ALLOC_ERROR;
    } else {
	struct c1_trans19_type *trans19_data;
	void *used;

	trans19_data = data;

	status = _x1f4_c1_link_mine(program_data, &used);
	if (status) {
	    program_data->n.free(program_data->n.data, data);
	} else {
	    void **link;

	    link = used;

	    if (0) {
	    } else {
		*link = NULL;

		*trans19 = trans19_data;

		trans19_data->e.sample = 0;

		trans19_data->e.head = NULL;
		trans19_data->e.port = NULL;
		trans19_data->e.tail = NULL;

		/*
		 * link and used are the same.  no need for both of them.
		 */
		trans19_data->i.link = link;
		trans19_data->i.used = used;

		trans19_data->i.miss = (char *) used + program_data->post;

		trans19_data->f.program_data = program_data;
	    }
	}
    }

    return status;
}
