/*
 * c1.v.c
 * Copyright (C) 2008-2014, 2016, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <c1-defs.h>
#include <c1-inter.h>
#include <c1-types.h>
#include <e4.h>

int
x1f4_side_routine(struct c1_trans19_type **trans19,
		  struct c1_program_type *program_data)
{
    int excess, (*free) (void *, void *), status = 0;
    struct c1_trans19_type *trans19_data;
    void *text;

    trans19_data = *trans19;

    free = program_data->n.free;
    text = program_data->n.data;

    _x1f4_c1_miss_fast(program_data, trans19_data->e.head);

    if (trans19_data->e.port) {
	excess = _x1f4_c1_miss_port(trans19_data);
	if (excess) {
	    if (status) {
	    } else {
		status = excess;
	    }
	}
    }

    /*
     * FEATURES
     *
     * -main- state is cleared even for successful execution (unfortunately?)
     */
    x1f4_mind_program(program_data, trans19_data->i.used);

    excess = free(text, trans19_data->i.link);
    if (excess) {
	if (status) {
	} else {
	    status = excess;
	}
    }

    excess = free(text, trans19_data);
    if (excess) {
	if (status) {
	} else {
	    status = excess;
	}
    }

    return status;
}
