/*
 * lxfile-x.r.c
 * Copyright (C) 2016, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <file.h>
#include <lxfile-defs.h>
#include <lxfile-types.h>

int
x1f4_hold_lxfile(void *dxfile, void **sdfile, const void **sffile)
{
    int status;
    struct dxfile_type *dxfile_data;
    void *file;

    dxfile_data = dxfile;

    file = dxfile_data->file;
    if (file) {
	if (dxfile_data->mode == READ_CLASS) {
	    _libx1f4i0_hold_ifile(file, sdfile, sffile);
	} else {
	    _libx1f4i0_hold_ofile(file, sdfile, sffile);
	}

	status = 0;
    } else {
	status = 1;
    }

    return status;
}
