/*
 * lxfile-x.s.c
 * Copyright (C) 2013, 2014, 2016, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <lxfile-types.h>

#define exfile(file) \
    ((struct exfile_type *) (file)->socket)

int
x1f4_land_lxfile(void *lxfile, void *dxfile, int *stored)
{
    int delete = 0;
    struct dxfile_type *dxfile_data;
    void *file;

    dxfile_data = dxfile;

    file = dxfile_data->file;
    if (file) {
	int (*lift)(void *, int *);

	lift = exfile(dxfile_data)->lift;
	if (lift) {
	    lift(file, stored);
	} else {
	    delete = 1;
	}
    } else {
	delete = 1;
    }

    return delete;
}
