/*
 * lxpart-a.g.c
 * Copyright (C) 2008-2010, 2013, 2015, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <stddef.h>

#include <lxpart-inter.h>
#include <lxpart-types.h>
#include <tcvset.h>

int
x1f4_line_lxpart(void *subtext, void **address)
{
    int status;
    struct lxpart_type *lxpart_data;
    struct lxtext_type *lxtext_data;
    void *dxpart;

    lxtext_data = subtext;

    lxpart_data = lxtext_data->part;

    status = lxpart_data->link_m.link
	(lxpart_data->link_m.data, &dxpart,
	 __struct_dxpart_type_alloc_size__ + lxtext_data->trap);
    if (status) {
	status = _libx1f4i0_lxpart_stat_link(lxpart_data);
    } else {
	dxpart = pick_dxpart(dxpart);

	status = lxtext_data->line(lxtext_data->text, dxpart);
	if (status) {
	    lxpart_data->link_m.free
		(lxpart_data->link_m.data, lock_cxpart(dxpart));
	} else {
	    lock_excase(dxpart)->nodetype_data = lxtext_data->nodetype;

	    lock_excase(dxpart)->slip = NULL;

	    lock_expart(dxpart)->call = 1;

	    _libx1f4i0_init_tcvset
		(&lock_expart(dxpart)->pset, &lock_expart(dxpart)->text);

	    *address = dxpart;
	}
    }

    return status;
}
