/*
 * lxpart-a.x.c
 * Copyright (C) 2008-2010, 2013-2016, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <exerrors.h>
#include <lxcall.h>
#include <lxpart-types.h>
#include <tcvset.h>

#define lxpart(part) \
    ((struct lxpart_type *) (part))

#define tccase(vset) \
    ((struct x1f4_tccase_type *) (vset))

int
x1f4_push_lxpart(void *subtext, void **copy, void *part,
		 const struct x1f4_nodelink_type *nodelink_data)
{
    int status;
    struct lxpart_type *lxpart_data;

    lxpart_data = ((struct lxtext_type *) subtext)->part;

    status = tccase(lock_expart(part)->text)->miss
	(&lock_expart(part)->pset, &lock_expart(part)->text, nodelink_data,
	 (void *) &lxpart_data->link_m);
    if (status) {
	status = X1f4_EX_CRITICAL;
    } else {
	do {
	    void *flat;

	    flat = *copy;
	    if (flat) {
		status = _libx1f4i0_lxcall_near_node
		    (&lxpart_data->link_v, &lxpart_data->link_e,
		     lxpart_data->link_t.datatype_data
		     + ((struct lxtext_type *) subtext
			- (struct lxtext_type *) lxpart_data->link_f.part),
		     flat);
		if (status) {
		    break;
		}
	    }

	    *copy = (void *) part;
	} while (0);
    }

    return status;
}
