/*
 * lxpart-e.e.c
 * Copyright (C) 2008-2015, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <exerrors.h>
#include <lxlead.h>
#include <lxpart-inter.h>
#include <lxpart-types.h>
#include <nl.h>
#include <tcvset.h>

#define lxpart(part) \
    ((struct lxpart_type *) (part))

#define tccase(vset) \
    ((struct x1f4_tccase_type *) (vset))

int
x1f4_pick_lxpart(void *subtext, void *dxpart,
		 struct x1f4_nodelink_type **nodelink,
		 const struct x1f4_nodelink_type *nodelink_data)
{
    int status;
    unsigned call;

    call = lock_expart(dxpart)->call;

    if (call) {
	call--;
	if (call) {
	    struct lxpart_type *lxpart_data;

	    lxpart_data = ((struct lxtext_type *) subtext)->part;

	    status = tccase(lock_expart(dxpart)->text)->miss
		(&lock_expart(dxpart)->pset, &lock_expart(dxpart)->text,
		 nodelink_data, &lxpart_data->link_m);
	    if (status) {
		status = X1f4_EX_CRITICAL;
	    } else {
		int (*fine) (void *, struct x1f4_nodelink_type **,
			     struct x1f4_nodelink_type *);

		lock_expart(dxpart)->call = call;

		fine = lxpart_data->link_r.fine;
		if (fine) {
		    status = fine
			(lxpart_data->link_r.text, nodelink,
			 lock_excase(dxpart));
		} else {
		    x1f4_side_lxlead(nodelink, dxpart);
		}
	    }
	} else {
	    status = 0;
	    if (lock_excase(dxpart)->slip) {
	    } else {
		lock_expart(dxpart)->call = 0;
		lock_excase(dxpart)->slip = *nodelink;
		*nodelink = lock_excase(dxpart);
	    }
	}
    } else {
	status = 0;
    }

    return status;
}
