/*
 * lxpart-f.s.c
 * Copyright (C) 2008-2010, 2013-2016, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <e4.h>
#include <lxcall.h>
#include <lxpart-types.h>

#define I_PART(t)			(*((X1f4_E4_C_USER *) (t)))

#define l_PART(e, output) \
    {									      \
	X1f4_E4_C_USER *l;						      \
									      \
	l = (void *) (output);						      \
	*l = (e);							      \
    }

#define lock_exdata(data) \
    (data)

int
_libx1f4i0_lxpart_s_forward(void *context, void *output, void **input)
{
    int status;
    struct dxpart_type *dxpart_flat, *dxpart_text;
    struct lxpart_type *lxpart_data;
    struct lxtext_type *lxtext_data;

    dxpart_flat = I_PART(input[0]);
    dxpart_text = I_PART(input[1]);

    lxtext_data = context;

    lxpart_data = lxtext_data->part;

    do {
	if (dxpart_flat) {
	    status = _libx1f4i0_lxcall_sand_node
		(&lxpart_data->link_v, &lxpart_data->link_e,
		 lxtext_data->nodetype, dxpart_flat);
	    if (status) {
		break;
	    }
	} else {
	    status = 0;
	}

	lock_expart(dxpart_text)->call++;

	l_PART(dxpart_text, input[0]);
	l_PART(dxpart_text, output);
    } while (0);

    return status;
}
