/*
 * lxpart-i.f.c
 * Copyright (C) 2008-2011, 2013, 2015, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <stddef.h>

#include <lxlead.h>
#include <lxpart-inter.h>
#include <nt.h>

int
_libx1f4i0_lxpart_time_part(struct x1f4_nodetype_type *nodetype_data,
			    struct cxpart_type *cxpart_data)
{
    nodetype_data->code = cxpart_data->type;
    nodetype_data->name = cxpart_data->name;
    nodetype_data->size = cxpart_data->size;
    nodetype_data->flags =
	X1f4_LX_AUTO_RECORD | X1f4_LX_LINK_ACCESS | X1f4_LX_NULL_RECORD
	| X1f4_LX_PICK_ACCESS | X1f4_LX_TYPE_EXCEPT;

    nodetype_data->call = x1f4_call_lxlead;
    nodetype_data->copy =
	cxpart_data->copy ? x1f4_copy_lxpart : x1f4_copy_lxstar;
    nodetype_data->dump = x1f4_dump_lxpart;
    nodetype_data->free = x1f4_free_lxpart;
    nodetype_data->hash = x1f4_hash_lxpart;
    nodetype_data->lead = x1f4_lead_lxpart;
    nodetype_data->miss = x1f4_near_lxlead;
    nodetype_data->move = x1f4_move_lxpart;
    nodetype_data->node = x1f4_node_lxpart;
    nodetype_data->pick = x1f4_pick_lxpart;
#if 0
    nodetype_data->post = NULL;
#endif				/* 0 */
    nodetype_data->push = x1f4_push_lxpart;
    nodetype_data->slip = x1f4_slip_lxpart;

    return 0;
}
