/*
 * lxpart-inter.h
 * Copyright (C) 2008-2016, Ciprian Niculescu
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __LIBx1f4_lxpart_inter_H__
#define __LIBx1f4_lxpart_inter_H__

#include <e4.h>
#include <lxpart-types.h>
#include <lxwide.h>
#include <nl.h>
#include <nt.h>

#define _libx1f4i0_lxpart_bset_part	x1f4_bset_lxpart
#define _libx1f4i0_lxpart_clip_part	x1f4_clip_lxpart
#define _libx1f4i0_lxpart_copy_part	x1f4_copy_lxpart
#define _libx1f4i0_lxpart_dset_part	x1f4_dset_lxpart
#define _libx1f4i0_lxpart_dump_part	x1f4_dump_lxpart
#define _libx1f4i0_lxpart_fini_part	x1f4_fini_lxpart
#define _libx1f4i0_lxpart_flat_part	x1f4_flat_lxpart
#define _libx1f4i0_lxpart_free_part	x1f4_free_lxpart
#define _libx1f4i0_lxpart_fset_part	x1f4_fset_lxpart
#define _libx1f4i0_lxpart_hash_part	x1f4_hash_lxpart
#define _libx1f4i0_lxpart_init_part	x1f4_init_lxpart
#define _libx1f4i0_lxpart_lead_part	x1f4_lead_lxpart
#define _libx1f4i0_lxpart_lift_part	x1f4_lift_lxpart
#define _libx1f4i0_lxpart_line_part	x1f4_line_lxpart
#define _libx1f4i0_lxpart_link_part	x1f4_link_lxpart
#define _libx1f4i0_lxpart_move_part	x1f4_move_lxpart
#define _libx1f4i0_lxpart_near_part	x1f4_near_lxpart
#define _libx1f4i0_lxpart_node_part	x1f4_node_lxpart
#define _libx1f4i0_lxpart_pick_part	x1f4_pick_lxpart
#define _libx1f4i0_lxpart_post_part	x1f4_post_lxpart
#define _libx1f4i0_lxpart_push_part	x1f4_push_lxpart
#define _libx1f4i0_lxpart_seek_part	x1f4_seek_lxpart
#define _libx1f4i0_lxpart_slip_part	x1f4_slip_lxpart
#define _libx1f4i0_lxpart_tile_part	x1f4_tile_lxpart
#define _libx1f4i0_lxpart_type_part	x1f4_type_lxpart

#define _libx1f4i0_lxpart_copy_star	x1f4_copy_lxstar

#define __types_long(lxpart) \
    (&((struct lxpart_type *) (lxpart))->ever_a)

#define _libx1f4i0_lxpart_stat_free(___l, ___1) \
    _libx1f4i0_lxlock_stat_free(__types_long((___l)), (___1))
#define _libx1f4i0_lxpart_stat_link(___l) \
    _libx1f4i0_lxlock_stat_link(__types_long((___l)))
#define _libx1f4i0_lxpart_stat_mode(___l) \
    _libx1f4i0_lxlock_stat_mode(__types_long((___l)))

extern int _libx1f4i0_lxpart_bset_part
    (void *, const struct x1f4_operator_type **);
extern int _libx1f4i0_lxpart_clip_part
    (const void *, struct x1f4_nodetype_type **, int *);
extern int _libx1f4i0_lxpart_copy_part
    (void *, void *, void **, const void *, const struct x1f4_nodelink_type *);
extern int _libx1f4i0_lxpart_copy_star
    (void *, void *, void **, const void *, const struct x1f4_nodelink_type *);
extern int _libx1f4i0_lxpart_dset_part
    (void *, const struct x1f4_datatype_type **);
extern int _libx1f4i0_lxpart_dump_part(void *, struct x1f4_nodelink_type *);
extern int _libx1f4i0_lxpart_fine_part(void *, void *);
extern int _libx1f4i0_lxpart_fini_part(void **);
extern int _libx1f4i0_lxpart_flat_part(void *, void **);
extern int _libx1f4i0_lxpart_free_part
    (void *, void *, struct x1f4_nodelink_type **,
     const struct x1f4_nodelink_type *);
extern int _libx1f4i0_lxpart_fset_part
    (void *, const struct x1f4_linetext_type **);
extern int _libx1f4i0_lxpart_hash_part
    (void *, struct x1f4_nodelink_type **, struct x1f4_nodelink_type *);
extern int _libx1f4i0_lxpart_heap_part
    (void *, struct x1f4_nodelink_type **, void *);
extern int _libx1f4i0_lxpart_init_part
    (void **, unsigned, const struct screen_type *);
extern int _libx1f4i0_lxpart_lead_part(void *, void **);
extern int _libx1f4i0_lxpart_lift_part(void *, int, void **);
extern int _libx1f4i0_lxpart_line_part(void *, void **);
extern int _libx1f4i0_lxpart_link_part(void *, void **);
extern int _libx1f4i0_lxpart_move_part
    (void *, void *, const struct x1f4_nodelink_type *,
     const struct x1f4_nodelink_type *);
extern int _libx1f4i0_lxpart_near_part(void *);
extern int _libx1f4i0_lxpart_node_part
    (void *, void **, void *, const struct x1f4_nodelink_type *);
extern int _libx1f4i0_lxpart_null_part
    (void *, struct x1f4_nodelink_type **, void *);
extern int _libx1f4i0_lxpart_pick_part
    (void *, void *, struct x1f4_nodelink_type **,
     const struct x1f4_nodelink_type *);
extern int _libx1f4i0_lxpart_post_part
    (void *, void **, const struct x1f4_nodelink_type *);
extern int _libx1f4i0_lxpart_push_part
    (void *, void **, void *, const struct x1f4_nodelink_type *);
extern int _libx1f4i0_lxpart_s_forward(void *, void *, void **);
extern int _libx1f4i0_lxpart_seek_part(const void *);
extern int _libx1f4i0_lxpart_side_part(void *, void *);
extern int _libx1f4i0_lxpart_slip_part(void *, void **);
extern int _libx1f4i0_lxpart_tile_part
    (void **, unsigned, struct x1f4_lxwide_type *, unsigned, const void *);
extern int _libx1f4i0_lxpart_time_part
    (struct x1f4_nodetype_type *, struct cxpart_type *);
extern int _libx1f4i0_lxpart_type_part
    (const void *, struct x1f4_nodetype_type *, int);

#endif				/* __LIBx1f4_lxpart_inter_H__ */
